VERSION 5.00
Begin VB.Form FrmVbToExl 
   BackColor       =   &H80000004&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Vb to Excel by Arun Banik"
   ClientHeight    =   2145
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   3870
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "FrmCallExcel.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Moveable        =   0   'False
   ScaleHeight     =   2145
   ScaleWidth      =   3870
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton CmdExport 
      Caption         =   "&Export"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2400
      TabIndex        =   1
      ToolTipText     =   "Export data"
      Top             =   430
      Width           =   1095
   End
   Begin VB.ListBox LstCode 
      BackColor       =   &H00808080&
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H0080FF80&
      Height          =   1230
      Left            =   360
      TabIndex        =   0
      ToolTipText     =   "Select a code to export"
      Top             =   480
      Width           =   1215
   End
   Begin VB.CommandButton CmdExit 
      Caption         =   "E&xit"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2400
      TabIndex        =   3
      ToolTipText     =   "Exit"
      Top             =   1440
      Width           =   1095
   End
   Begin VB.CommandButton CmdHelp 
      Caption         =   "&Help"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   2400
      TabIndex        =   2
      ToolTipText     =   "Learn more about the project"
      Top             =   930
      Width           =   1095
   End
   Begin VB.Label lblHead 
      BackStyle       =   0  'Transparent
      Caption         =   "Select a Code"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   360
      TabIndex        =   4
      Top             =   120
      Width           =   1335
   End
   Begin VB.Shape frame 
      BackColor       =   &H00C0E0FF&
      BorderColor     =   &H00E0E0E0&
      BorderWidth     =   2
      FillColor       =   &H00C0C0C0&
      FillStyle       =   0  'Solid
      Height          =   1755
      Index           =   0
      Left            =   120
      Shape           =   4  'Rounded Rectangle
      Top             =   240
      Width           =   3630
   End
End
Attribute VB_Name = "FrmVbToExl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'******************************************************************************
'******************************************************************************
'*** VB to Excel                                                            ***
'*** Author    : Arun Banik (Mumbai, India)                                 ***
'*** E-mail    : arun7331@hotmail.com                                       ***
'***                                                                        ***
'*** Purpose   : It is an enhanced version of my previously submitted       ***
'***             code. The purpose of this programme is to generate         ***
'***             report by exporting data into an Ms-Excel sheet from       ***
'***             an Ms-Access database. It will also display the            ***
'***             sub total and grand total of the amount column at          ***
'***             runtime. In this report, I am using the date column        ***
'***             as the group.                                              ***
'***      ###############################################################   ***
'***             To see more codes submitted by me, type the URL            ***
'***             http://www.vbcode.com/default.htm, and enter Arun Banik    ***
'***             in the Search Database box and press enter.                ***
'***      ###############################################################   ***
'*** Note:       Due to lots of feedback from many developers I have made   ***
'***             some changes and included more functions into this project,***
'***             so that the reports can be generated quickly and           ***
'***             efficiently. Thanks very much for all the feedbacks and    ***
'***             sugestions.                                                ***
'*** What's New : 1) The whole sheet is protected by a password, using a    ***
'***             function called Protect. Eg: Worksheet.Protect.            ***
'***             In this demo project, I have used the Protect function to  ***
'***             prevent the sheet from editing, ie., the sheet cannot be   ***
'***             modified till a password is entered. Excel will prompt for ***
'***             a password when the user UnProtects the sheet. To UnProtect***
'***             the sheet goto Tools menu and click Protection submenu and ***
'***             select Unprotect Sheet... Excel will prompt the user to    ***
'***             enter a password. For this project I have set the password ***
'***             as 'Arun'.                                                 ***
'***                                                                        ***
'***              2) To modify a particular cell, we need to set the cells  ***
'***             locked property to false BEFORE setting the the sheet as   ***
'***             protected . For this I have set the                        ***
'***             Cells(10,4).locked = False. Any number of cells, a         ***
'***             particular row or rows can be set as .locked = False. It   ***
'***             will mean that when you PROTECT the whole sheet from editing,
'***             only these UNLOCK cells will be allowed for editing.       ***
'***             Rest will be in read mode.                                 ***
'***
'***              3) The report is generated much faster than the previous  ***
'***             version.                                                   ***
'***                                                                        ***
'***              You got any comments or suggestions please send me a      ***
'***              mail at arun7331@hotmail.com                              ***
'***                                                                        ***
'***              LET ME KNOW IF YOU HAVE PROJECTS TO DEVELOPE.             ***
'***              VB OR ASP.                                                ***
'******************************************************************************
'******************************************************************************
'Option Explicit

Private Sub Form_Load()
    DoEvents

    ' Populate the list box with distinct code
    rsGetDistCode.Open "Select Distinct trcode From TRPC0104", con, adOpenDynamic, adLockReadOnly
    While Not rsGetDistCode.EOF
        LstCode.AddItem rsGetDistCode!trcode
        rsGetDistCode.MoveNext
    Wend
End Sub

Private Sub Form_Activate()
    SetCursorPos ((Screen.Width - Me.Width) / 2) / 15 + _
                LstCode.Left / 15 + LstCode.Width / 30, _
                ((Screen.Height - Me.Height) / 2) / 15 + _
                LstCode.Top / 15 + LstCode.Height / 30
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Set con = Nothing
    Set ExlObj = Nothing
    Set rsGetDistCode = Nothing
    Set rsGetAllData = Nothing
    End
End Sub

Private Sub LstCode_DblClick()
    CmdExport_Click
End Sub

Private Sub LstCode_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = 13 Then
        CmdExport_Click
    End If
End Sub

Private Sub CmdExport_Click()
' Description: The event of this button will open an Excel sheet, _
    with all the data from an Access database. Functions like _
    Autoformat and Protect are used to generate more acurate _
    and secured reports.
On Error Resume Next

    ' Counters.
    Dim lc          As Integer
    Dim iNxtLine    As Integer
    Dim iFldCnt     As Integer                  ' Field counter.
    Dim iCnt        As Integer
    
    Dim vFld        As Variant
    
    If Trim(LstCode.Text) <> "" Then
        Screen.MousePointer = vbHourglass

        Set ExlObj = CreateObject("excel.application")      ' Initialize the excel object.
        ExlObj.Workbooks.Add                                ' Add an excel workbook.
        ' Get the required data from the database
        rsGetAllData.Open "Select ACCODE,CONTROL,TRNOS,DATE,TRCODE,AMOUNT,STAFFNOS as STAFF from " & _
                 "TRPC0104 where TRCODE = '" + Trim(LstCode.Text) + "'", con, adOpenDynamic, adLockOptimistic
        Set rsGetAllData.ActiveConnection = Nothing
                         
        If Not rsGetAllData.EOF Then
            ExlObj.Visible = True         ' Show the excel sheet.
            With ExlObj.ActiveSheet
                ' Print the heading and columns first.
                .Cells(1, 3).Value = "Visual Basic to Excel by Arun Banik"
                .Cells(1, 3).Font.Name = "Tahoma"
                .Cells(1, 3).Font.Bold = True
                
                iFldCnt = 1
                For Each vFld In rsGetAllData.Fields
                    .Cells(4, iFldCnt).Value = vFld.Name
                    iFldCnt = iFldCnt + 1
                Next vFld
            End With
        End If
        
        iFldCnt = 0
        
        iNxtLine = 5
        
        ' Now we will export data into the sheet
        Do Until rsGetAllData.EOF
            For lc = 0 To rsGetAllData.Fields.Count - 1
                DoEvents
                ExlObj.ActiveSheet.Cells(iNxtLine, lc + 1).Value = rsGetAllData.Fields(lc)
                If rsGetAllData.Fields.Item(lc).Name = "DATE" Then
                    ExlObj.ActiveSheet.Cells(iNxtLine, lc + 1).Value = Format(rsGetAllData.Fields(lc), "dd/mm/yy")
                End If
            Next
            rsGetAllData.MoveNext
            iNxtLine = iNxtLine + 1
        Loop
        
        ' Once the data has been exported, we will format the sheet _
          by using the AutoFormat function.
        ExlObj.ActiveCell.Worksheet.Cells(iNxtLine, lc).AutoFormat _
            xlRangeAutoFormatList2
        'ExlObj.ActiveCell.Worksheet.Cells.AutoFormat  '<- Click the space key after _
                                                         .AutoFormat to see its _
                                                         parameter types.
                                                           
        ' The parameters of .AutoFormat function. _
         1) xlRangeAutoFormatList2 - Format style _
         2) Number format _
         3) Font _
         4) Cell Alignment (Left 1, Right 2 and Center 3). We can change the _
            alignments accordingly. _
         5) Border _
         6) Pattern. Change the pattern to false and see what happens. _
         7) Width/Height. Change it to false and see what happens.
            ' With the .AutoFormat function we don't have to worry about setting _
              the width and height of the cells. Every thing is done automaticaly by _
              the function itself. For more, open Excel Sheet and goto Format menu. _
              Click AutoFormat submenu and select the Options button.
        
        ' Now calculate the total using .Subtotal function
        ExlObj.ActiveCell.Worksheet.Cells(4, 1).Subtotal 4, xlSum, (6), 0, 0, xlSummaryBelow
       
        ' I am protecting the whole sheet, except the cell(10,4), which will be unlocked _
          for modification. We can select any number cells or a particular row for _
          modification if the the whole sheet has been protected by a password.
          
        ' So first unlock the cell, which is to be modified if the the sheet is protected.
        ExlObj.ActiveCell.Worksheet.Cells(10, 4).Locked = False
        ' Then protect the whole sheet by using a password.
        ExlObj.ActiveCell.Worksheet.Protect "Arun", False, True, True, False
        
       ' The Protect function mentioned above takes four parameters. _
        1) Password:  Optional Variant.  A string that specifies a _
           case-sensitive password for the worksheet or workbook. If this argument _
           is omitted, you can unprotect the worksheet or workbook without using a _
           password. Otherwise, you must specify the password to unprotect the _
           worksheet or workbook. If you forget the password, you cannot unprotect the _
           worksheet or workbook. _
        2) DrawingObjects:  Optional Variant. True to protect shapes. The default value _
           is False. _
        3) Contents:  Optional Variant. True to protect contents. For a chart, _
           this protects the entire chart. For a worksheet, this protects the _
           locked cells. The default value is True. _
        4) Scenarios:  Optional Variant. True to protect scenarios. This argument _
           is valid only for worksheets. The default value is True. _
        5) UserInterfaceOnly:  Optional Variant. True to protect the user interface, _
           but not macros. If this argument is omitted, protection applies both to _
           macros and to the user interface.
        
        For iFldCnt = 1 To rsGetAllData.Fields.Count
            ' Column headings are set to bold and white.
            ExlObj.ActiveSheet.Cells(4, iFldCnt).Font.Bold = True
            ExlObj.ActiveSheet.Cells(4, iFldCnt).Font.Color = vbWhite
        Next
        iFldCnt = 0
        
        Screen.MousePointer = vbDefault
    Else
        MsgBox "Please select a code and then proceed.", vbInformation, "Invalid Code"
        LstCode.SetFocus
        Screen.MousePointer = vbDefault
        Exit Sub
    End If

End Sub

Private Sub CmdHelp_Click()
    MsgBox "Select a code like BK, BP or Br etc using the UP and DOWN key and press Enter or click the Export button." & _
    "You can also Double Click the selected code." & vbCrLf & _
           "The excel sheet which will open is a protected sheet ie., " & vbCrLf & _
           "it cannot be modified unless you enter a password. To UnProtect" & vbCrLf & _
           "the sheet goto Excel Tools menu and click Protection Submenu and then" & vbCrLf & _
           "select UnProtect Sheet. Excel will prompt a password. Enter the" & vbCrLf & _
           "password as Arun. (Passwords are case sensitive) Once the correct" & vbCrLf & _
           "password is entered excel will allow editing of the sheet." & vbCrLf & _
           "Excel sheets can be protected from Visual basic. Also particular" & vbCrLf & _
           "cells or rows can be set for editing from Visual basic. In this" & vbCrLf & _
           "project I have made the cells(10,4) as editable while the" & vbCrLf & _
           "sheet is protected." & vbCrLf & vbCrLf & _
           "This is a demo project, designed basicaly for programmers," & vbCrLf & _
           "who wants to design report or export data into Ms-Excel sheets." & vbCrLf & _
           "Multiple sheets can be scaned and uploaded from excel to any database.", vbInformation, "Quick Help"
End Sub

Private Sub CmdExit_Click()
    If MsgBox("Want to quit ?", vbQuestion + vbYesNo, Me.Caption) = vbYes Then
        ' Clean up.
        Set con = Nothing
        Set ExlObj = Nothing
        Set rsGetDistCode = Nothing
        Set rsGetAllData = Nothing
        End
    End If
End Sub

'7, 17


